apiVersion: v1
kind: Template
labels:
  app: httpexporter
  template: httpexporter-persistent
metadata:
  annotations:
    description: Demo Apache Prometheus Exporter - persistent
    iconClass: icon-openshift
    openshift.io/display-name: Prometheus Apache Exporter
    tags: httpexporter
  name: httpexporter-persistent
objects:
- apiVersion: v1
  kind: PersistentVolumeClaim
  metadata:
    name: openldap-${FRONTNAME}-conf
  spec:
    accessModes:
    - ReadWriteOnce
    resources:
      requests:
        storage: ${OPENLDAP_CONF_VOLUME_CAPACITY}
- apiVersion: v1
  kind: PersistentVolumeClaim
  metadata:
    name: openldap-${FRONTNAME}-data
  spec:
    accessModes:
    - ReadWriteOnce
    resources:
      requests:
        storage: ${OPENLDAP_DATA_VOLUME_CAPACITY}
- apiVersion: v1
  kind: DeploymentConfig
  metadata:
    labels:
      name: openldap-${FRONTNAME}
    name: openldap-${FRONTNAME}
  spec:
    replicas: 1
    selector:
      name: openldap-${FRONTNAME}
    strategy:
      type: Recreate
    template:
      metadata:
        labels:
          name: openldap-${FRONTNAME}
      spec:
        dnsPolicy: ClusterFirst
        containers:
        - capabilities: {}
          env:
          - name: OPENLDAP_BIND_LDAP_PORT
            value: "1389"
          - name: OPENLDAP_BIND_LDAPS_PORT
            value: "1636"
          - name: OPENLDAP_BLUEMIND_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: bluemind-password
          - name: OPENLDAP_DEBUG_LEVEL
            value: "${OPENLDAP_DEBUG_LEVEL}"
          - name: OPENLDAP_DEMO_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: demo-password
          - name: OPENLDAP_FUSION_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: fusion-password
          - name: OPENLDAP_HOST_ENDPOINT
            value: openldap-${FRONTNAME}
          - name: OPENLDAP_LEMONLDAP_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: lemonldap-password
          - name: OPENLDAP_LEMONLDAP_HTTPS
            value: "yes"
          - name: OPENLDAP_LEMONLDAP_SESSIONS_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: lemonldap-sessions-password
          - name: OPENLDAP_LEMON_HTTP_PORT
            value: "8080"
          - name: OPENLDAP_MEDIAWIKI_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: mediawiki-password
          - name: OPENLDAP_MONITOR_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: monitor-password
          - name: OPENLDAP_NEXTCLOUD_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: nextcloud-password
          - name: OPENLDAP_ORG_SHORT
            value: "${ORG_NAME}"
          - name: OPENLDAP_ROCKET_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: rocket-password
          - name: OPENLDAP_ROOT_DN_PREFIX
            value: cn=admin
          - name: OPENLDAP_ROOT_DN_SUFFIX
            value: "${BASE_SUFFIX}"
          - name: OPENLDAP_ROOT_DOMAIN
            value: "${ROOT_DOMAIN}"
          - name: OPENLDAP_ROOT_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: root-password
          - name: OPENLDAP_SMTP_SERVER
            value: "${SMTP_RELAY}"
          - name: OPENLDAP_SSO_CLIENT_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: ssoapp-password
          - name: OPENLDAP_SSP_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: ssp-password
          - name: OPENLDAP_SYNCREPL_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: syncrepl-password
          - name: OPENLDAP_WHITEPAGES_PASSWORD
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: whitepages-password
          imagePullPolicy: IfNotPresent
          livenessProbe:
            initialDelaySeconds: 30
            timeoutSeconds: 1
            tcpSocket:
              port: 1389
          name: openldap
          ports:
          - containerPort: 1389
            protocol: TCP
          - containerPort: 1636
            protocol: TCP
          readinessProbe:
            exec:
              command:
              - /bin/sh
              - "-i"
              - "-c"
              - /usr/local/bin/is-ready.sh
            initialDelaySeconds: 5
            timeoutSeconds: 1
          resources:
            limits:
              cpu: "${OPENLDAP_CPU_LIMIT}"
              memory: "${OPENLDAP_MEMORY_LIMIT}"
          terminationMessagePath: /dev/termination-log
          volumeMounts:
          - name: conf
            mountPath: /etc/openldap
          - name: data
            mountPath: /var/lib/ldap
          - name: run
            mountPath: /run
        restartPolicy: Always
        volumes:
        - name: conf
          persistentVolumeClaim:
            claimName: openldap-${FRONTNAME}-conf
        - name: data
          persistentVolumeClaim:
            claimName: openldap-${FRONTNAME}-data
        - emptyDir: {}
          name: run
    triggers:
    - type: ImageChange
      imageChangeParams:
        automatic: true
        containerNames:
        - openldap
        from:
          kind: ImageStreamTag
          name: ${OPENLDAP_IMAGESTREAM_TAG}
        lastTriggeredImage: ''
    - type: ConfigChange
- apiVersion: v1
  kind: Service
  metadata:
    name: openldap-${FRONTNAME}
  spec:
    ports:
    - name: ldap
      protocol: TCP
      port: 1389
      targetPort: 1389
      nodePort: 0
    - name: ldaps
      protocol: TCP
      port: 1636
      targetPort: 1636
      nodePort: 0
    selector:
      name: openldap-${FRONTNAME}
    type: ClusterIP
- apiVersion: v1
  kind: DeploymentConfig
  metadata:
    labels:
      name: lemon-${FRONTNAME}
    name: lemon-${FRONTNAME}
  spec:
    replicas: 1
    selector:
      name: lemon-${FRONTNAME}
    strategy:
      type: Rolling
    template:
      metadata:
        labels:
          name: lemon-${FRONTNAME}
      spec:
        dnsPolicy: ClusterFirst
        hostAliases:
        - ip: "127.0.0.1"
          hostnames:
          - "auth.${ROOT_DOMAIN}"
          - "manager.${ROOT_DOMAIN}"
          - "reload.${ROOT_DOMAIN}"
          - "stats"
        containers:
        - capabilities: {}
          env:
          - name: OPENLDAP_BASE
            value: "${BASE_SUFFIX}"
          - name: OPENLDAP_BIND_DN_PREFIX
            value: cn=lemonldap,ou=services
          - name: OPENLDAP_BIND_PW
            valueFrom:
              secretKeyRef:
                name: openldap-${FRONTNAME}
                key: lemonldap-password
          - name: OPENLDAP_CONF_DN_PREFIX
            value: ou=lemonldap,ou=config
          - name: OPENLDAP_DOMAIN
            value: "${ROOT_DOMAIN}"
          - name: OPENLDAP_HOST
            value: openldap-${FRONTNAME}
          - name: OPENLDAP_HTTP_PORT
            value: "8080"
          - name: OPENLDAP_PORT
            value: "1389"
          - name: OPENLDAP_PROTO
            value: ldap
          imagePullPolicy: IfNotPresent
          livenessProbe:
            failureThreshold: 15
            httpGet:
              path: /
              port: 8080
            initialDelaySeconds: 30
            periodSeconds: 20
            timeoutSeconds: 8
          name: lemon
          ports:
          - containerPort: 8080
            protocol: TCP
          readinessProbe:
            httpGet:
              path: /
              port: 8080
            initialDelaySeconds: 5
            periodSeconds: 20
            timeoutSeconds: 5
          resources:
            limits:
              cpu: "${LEMON_CPU_LIMIT}"
              memory: "${LEMON_MEMORY_LIMIT}"
          terminationMessagePath: /dev/termination-log
          volumeMounts:
          - name: apachesites
            mountPath: /etc/apache2/sites-enabled
          - name: etcconf
            mountPath: /etc/lemonldap-ng
        - capabilities: {}
          args:
          - -scrape_uri
          - "http://stats:8080/server-status"
          image: ' '
          imagePullPolicy: IfNotPresent
          livenessProbe:
            initialDelaySeconds: 30
            timeoutSeconds: 1
            tcpSocket:
              port: 9113
          name: exporter
          ports:
          - containerPort: 9113
            protocol: TCP
          readinessProbe:
            initialDelaySeconds: 5
            httpGet:
              path: /
              port: 9113
            periodSeconds: 20
            timeoutSeconds: 5
          resources:
            limits:
              cpu: "${EXPORTER_CPU_LIMIT}"
              memory: "${EXPORTER_MEMORY_LIMIT}"
        restartPolicy: Always
        volumes:
        - emptyDir: {}
          name: etcconf
        - emptyDir: {}
          name: apachesites
    triggers:
    - type: ImageChange
      imageChangeParams:
        automatic: true
        containerNames:
        - lemon
        from:
          kind: ImageStreamTag
          name: ${LEMON_IMAGESTREAM_TAG}
        lastTriggeredImage: ''
    - type: ImageChange
      imageChangeParams:
        automatic: true
        containerNames:
        - exporter
        from:
          kind: ImageStreamTag
          name: httpexporter:${APACHE_EXPORTER_IMAGE_TAG}
        lastTriggeredImage: ''
    - type: ConfigChange
- apiVersion: v1
  kind: Service
  metadata:
    name: lemon-${FRONTNAME}
  spec:
    ports:
    - name: sso
      port: 8080
      targetPort: 8080
    selector:
      name: lemon-${FRONTNAME}
- apiVersion: v1
  kind: Service
  metadata:
    annotations:
      description: Exposes Lemon Prometheus Exporter
    labels:
      ${PROMETHEUS_SERVICE_SELECTOR}: ${PROMETHEUS_SERVICE_MATCH}
    name: lemonexporter-${FRONTNAME}
  spec:
    ports:
    - name: exporter
      port: 9113
      targetPort: 9113
    selector:
      name: lemon-${FRONTNAME}
    type: ClusterIP
- apiVersion: v1
  kind: Route
  metadata:
    name: lemon-${FRONTNAME}-reload
  spec:
    host: reload.${ROOT_DOMAIN}
    to:
      kind: Service
      name: lemon-${FRONTNAME}
    tls:
      insecureEdgeTerminationPolicy: Redirect
      termination: edge
- apiVersion: v1
  kind: Route
  metadata:
    name: lemon-${FRONTNAME}-manager
  spec:
    host: manager.${ROOT_DOMAIN}
    to:
      kind: Service
      name: lemon-${FRONTNAME}
    tls:
      insecureEdgeTerminationPolicy: Redirect
      termination: edge
- apiVersion: v1
  kind: Route
  metadata:
    name: lemon-${FRONTNAME}-auth
  spec:
    host: auth.${ROOT_DOMAIN}
    to:
      kind: Service
      name: lemon-${FRONTNAME}
    tls:
      insecureEdgeTerminationPolicy: Redirect
      termination: edge
parameters:
- name: APACHE_EXPORTER_IMAGE_TAG
  description: The ImageStreamTag we should pull images from
  displayName: Tag
  required: true
  value: master
- name: EXPORTER_CPU_LIMIT
  description: Maximum amount of CPU an exporter container can use
  displayName: Exporters CPU Limit
  required: true
  value: 50m
- name: EXPORTER_MEMORY_LIMIT
  description: Maximum amount of Memory an exporter container can use
  displayName: Exporters Memory Limit
  required: true
  value: 64Mi
- name: FRONTNAME
  description: The name identifier assigned to objects defined in this template
  displayName: Name
  required: true
  value: demo
- name: LEMON_CPU_LIMIT
  description: Maximum amount of CPU a Lemon container can use
  displayName: Lemon CPU Limit
  required: true
  value: 300m
- name: LEMON_IMAGESTREAM_TAG
  description: LemonLDAP-NG Image Tag
  displayName: LemonLDAP-NG ImageStream Tag
  required: true
  value: lemon:master
- name: LEMON_MEMORY_LIMIT
  description: Maximum amount of memory a Lemon container can use
  displayName: Lemon Memory Limit
  required: true
  value: 512Mi
- name: OPENLDAP_CONF_VOLUME_CAPACITY
  description: Volume space available for OpenLDAP configuration, e.g. 512Mi, 2Gi.
  displayName: OpenLDAP Config Volume Capacity
  required: true
  value: 512Mi
- name: OPENLDAP_CPU_LIMIT
  description: Maximum amount of CPU an OpenLDAP container can use
  displayName: OpenLDAP CPU Limit
  required: true
  value: 300m
- name: OPENLDAP_DATA_VOLUME_CAPACITY
  description: Volume space available for OpenLDAP database, e.g. 512Mi, 2Gi.
  displayName: OpenLDAP Data Volume Capacity
  required: true
  value: 8Gi
- name: OPENLDAP_DEBUG_LEVEL
  description: OpenLDAP log level
  displayName: LDAP Log Level
  required: true
  value: '256'
- name: OPENLDAP_IMAGESTREAM_TAG
  description: OpenLDAP Image Tag
  displayName: OpenLDAP ImageStream Tag
  required: true
  value: openldap:master
- name: OPENLDAP_MEMORY_LIMIT
  description: Maximum amount of memory an OpenLDAP container can use
  displayName: OpenLDAP Memory Limit
  required: true
  value: 512Mi
- name: PROMETHEUS_SERVICE_SELECTOR
  description: Prometheus Selector (key)
  displayName: Prometheus Service Selector Key
  required: true
  value: prometheus
- name: PROMETHEUS_SERVICE_MATCH
  description: Prometheus Selector (value)
  displayName: Prometheus Service Selector Value
  required: true
  value: scrape-me
- name: BASE_SUFFIX
  description: OpenLDAP base suffix
  displayName: LDAP Base Suffix
  required: true
  value: dc=demo,dc=local
- name: ORG_NAME
  description: Organization Display Name
  displayName: Organization Display Name
  required: true
  value: Demo
- name: ROOT_DOMAIN
  description: Root Domain
  displayName: Root Domain
  required: true
  value: demo.local
- name: SMTP_RELAY
  description: SMTP Relay
  displayName: SMTP Relay
  required: true
  value: smtp.demo.local
